SystemOrganization addCategory: #'GSoC-SpeechBubbles'!

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 8/12/2010 20:16'!
attachTo: aPlayer
self sendMessageToCostume: #target: with: aPlayer costume renderedMorph
! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 8/12/2010 20:16'!
getAttachment
	^ [(self sendMessageToCostume: #target) assuredPlayer]
		on: Error
		do: [self presenter standardPlayer] ! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 6/17/2010 00:02'!
getBubble
^[self costume renderedMorph bubble assuredPlayer] on: Error do: [self presenter standardPlayer]! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:50'!
sayGraphic: aGraphic
self costume renderedMorph sayGraphic: aGraphic! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:48'!
sayNumber: aNumber
self costume renderedMorph say: aNumber asString! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/6/2010 15:43'!
sayObject: aPlayer
self costume renderedMorph sayObject: aPlayer! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:47'!
sayText: aString
self costume renderedMorph say: aString! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 8/12/2010 20:16'!
stopAttaching
	self sendMessageToCostume: #target: with: nil! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 14:47'!
stopSayingOrThinking
self costume renderedMorph stopSayingOrThinking! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:50'!
thinkGraphic: aGraphic
self costume renderedMorph thinkGraphic: aGraphic! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:48'!
thinkNumber: aNumber
self costume renderedMorph think: aNumber asString! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/6/2010 15:43'!
thinkObject: aPlayer
self costume renderedMorph thinkObject: aPlayer! !

!Player methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:48'!
thinkText: aString
self costume renderedMorph think: aString! !

!Morph class methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 14:46'!
additionsToViewerCategorySpeechBubbles
	^#(
		#'speech bubbles' 
		(
			(command sayText: '' String)
			(command thinkText: '' String)
			(command sayNumber: '' Number)
			(command thinkNumber: '' Number)
			(command sayGraphic: '' Graphic)
			(command thinkGraphic: '' Graphic)
			(command sayObject: '' Player)
			(command thinkObject: '' Player)
			(command stopSayingOrThinking '')
			(slot bubble '' Player readOnly Player getBubble Player unused)		
		))! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 6/17/2010 00:01'!
bubble
	^self valueOfProperty: #bubble ifAbsent: [nil].! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:51'!
sayGraphic: aForm
self showGraphic: aForm inBubbleType: #speech! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/6/2010 15:44'!
sayObject: aPlayer
self showObject: aPlayer inBubbleType: #speech! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 6/16/2010 21:37'!
say: aString
self showMessage: aString inBubbleType: #speech! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 13:54'!
showGraphic: aForm inBubbleType: typeSymbol
| currentBubble |
currentBubble := self bubble.
currentBubble notNil ifTrue: [
	(currentBubble form = aForm and: [currentBubble type = typeSymbol and: [currentBubble isInWorld]]) ifTrue: [^self].
	currentBubble delete].
self setProperty: #bubble toValue: (SpeechBubbleMorph form: aForm type: typeSymbol for: self).! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 13:54'!
showMessage: aString inBubbleType: typeSymbol
| currentBubble |
currentBubble := self bubble.
currentBubble notNil ifTrue: [
	(currentBubble string = aString and: [currentBubble type = typeSymbol and: [currentBubble isInWorld]]) ifTrue: [^self].
	currentBubble delete].
aString isEmpty ifTrue: [^self removeProperty: #bubble].
self setProperty: #bubble toValue: (SpeechBubbleMorph string: aString type: typeSymbol for: self)! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 20:15'!
showObject: aPlayer inBubbleType: typeSymbol
| currentBubble morph |
morph := aPlayer costume renderedMorph.
currentBubble := self bubble.
currentBubble notNil ifTrue: [
	(currentBubble msgMorph = morph and: [currentBubble type = typeSymbol and: [currentBubble isInWorld]]) ifTrue: [^self].
	currentBubble delete].
self setProperty: #bubble toValue: (SpeechBubbleMorph morph: morph  type: typeSymbol for: self).! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/9/2010 14:48'!
stopSayingOrThinking
| currentBubble |
currentBubble := self bubble.
currentBubble isNil ifTrue: [^self].
currentBubble delete! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/2/2010 17:52'!
thinkGraphic: aForm
self showGraphic: aForm inBubbleType: #thought! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 7/6/2010 15:44'!
thinkObject: aPlayer
self showObject: aPlayer inBubbleType: #thought! !

!Morph methodsFor: '*GSoC-SpeechBubbles' stamp: 'Richo 6/16/2010 21:37'!
think: aString
self showMessage: aString inBubbleType: #thought! !

Morph subclass: #SpeechBubbleMorph
	instanceVariableNames: 'type balloon tail target lastHash stepTime msgMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSoC-SpeechBubbles'!

SpeechBubbleMorph class
	instanceVariableNames: 'speakingForm topLeftCornerForm thinkingForm'!

SpeechBubbleMorph class
	instanceVariableNames: 'speakingForm topLeftCornerForm thinkingForm'!

!SpeechBubbleMorph class methodsFor: 'viewer categories' stamp: 'Richo 6/16/2010 21:44'!
additionsToViewerCategoryBubble
	"Answer viewer additions for the 'bubble' category"

	^#(
		bubble 
		(
			(command attachTo: '' Player)
			(command stopAttaching '')
			(slot attachment '' Player readOnly Player getAttachment Player unused)		
		)
	)
! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/14/2010 11:08'!
bottomLeftCornerForm
^self topLeftCornerForm flipBy: #vertical centerAt: self topLeftCornerForm boundingBox topCenter! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/14/2010 11:08'!
bottomRightCornerForm
^(self topLeftCornerForm flipBy: #horizontal centerAt: self topLeftCornerForm boundingBox leftCenter) flipBy: #vertical centerAt: self topLeftCornerForm boundingBox topCenter! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 7/6/2010 13:03'!
form: aForm type: aSymbol
^(self basicNew setMorph: (SketchMorph withForm: aForm) type: aSymbol) initialize! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 7/2/2010 18:39'!
form: aForm type: aSymbol for: aMorph
^(self form: aForm type: aSymbol) target: aMorph! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 7/6/2010 12:45'!
morph: aMorph type: aSymbol 
^(self basicNew setMorph: aMorph type: aSymbol) initialize! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 7/6/2010 15:50'!
morph: aMorph type: aSymbol for: targetMorph
^(self morph: aMorph type: aSymbol) target: targetMorph! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 6/14/2010 15:11'!
new
	^self string: 'Hello world!!'! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/16/2010 21:10'!
speakingForm
"
speakingForm := nil
"
^speakingForm ifNil: [speakingForm := (Form
	extent: 56@51
	depth: 16
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147418113 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)]! !

!SpeechBubbleMorph class methodsFor: 'parts bin' stamp: 'Richo 7/2/2010 18:50'!
speechGraphicPrototype
	^self form: (ScriptingSystem formAtKey: 'Painting') type: #speech! !

!SpeechBubbleMorph class methodsFor: 'parts bin' stamp: 'Richo 6/16/2010 21:33'!
speechPrototype
	^self string: 'Hello world!!' type: #speech! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 6/14/2010 15:12'!
string: aString 
^self string: aString type: #speech! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 7/6/2010 13:06'!
string: aString type: aSymbol
"self string: 'Hello world!!' type: #speech"
| text instance |
text := (UserText new contents: aString) centered.
text width > 300 ifTrue: [text contents: aString wrappedTo: 300].
text on: #keyStroke send: #keyStroke:morph: to: (instance := self basicNew).
^(instance setMorph: text type: aSymbol) initialize! !

!SpeechBubbleMorph class methodsFor: 'instance creation' stamp: 'Richo 6/14/2010 15:12'!
string: aString type: aSymbol for: aMorph
"self string: 'Hello world!!' type: #speech for: Morph new openInHand"
^(self string: aString type: aSymbol) target: aMorph! !

!SpeechBubbleMorph class methodsFor: 'parts bin' stamp: 'Richo 8/14/2010 13:17'!
supplementaryPartsDescriptions
	"Answer a list of DescriptionForPartsBin objects that characterize objects that this class wishes to contribute to Stationery bins *other* than by the standard default #newStandAlone protocol"

	^ {
	DescriptionForPartsBin
		formalName: 'Speech bubble' translatedNoop
		categoryList: #('Just for Fun')
		documentation: '' translatedNoop
		globalReceiverSymbol: #SpeechBubbleMorph
		nativitySelector: #speechPrototype.

	DescriptionForPartsBin
		formalName: 'Thought bubble' translatedNoop
		categoryList: #('Just for Fun')
		documentation: '' translatedNoop
		globalReceiverSymbol: #SpeechBubbleMorph
		nativitySelector: #thoughtPrototype.

	DescriptionForPartsBin
		formalName: 'Speech bubble (graphic)' translatedNoop
		categoryList: #('Just for Fun')
		documentation: '' translatedNoop
		globalReceiverSymbol: #SpeechBubbleMorph
		nativitySelector: #speechGraphicPrototype.

	DescriptionForPartsBin
		formalName: 'Thought bubble (graphic)' translatedNoop
		categoryList: #('Just for Fun')
		documentation: '' translatedNoop
		globalReceiverSymbol: #SpeechBubbleMorph
		nativitySelector: #thoughtGraphicPrototype.
}
! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/16/2010 21:07'!
thinkingForm
"
thinkingForm := nil
thinkingForm
"
^thinkingForm ifNil: [thinkingForm := (Form
	extent: 56@49
	depth: 16
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 65537 65537 65537 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 65537 65537 2147450879 2147450879 2147450879 65537 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 65537 65537 65537 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 1 65537 65537 65537 65537 65537 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 65537 65537 98303 2147450879 2147418113 65537 65537 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147418113 65537 65536 1 65537 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 65536 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 65537 65537 65537 2147450879 2147450879 2147450879 65537 65537 65537 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 0 1 65537 65537 65537 65537 65537 65537 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 1 65537 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147418113 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65536 0 1 65537 98303 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65537 65537 65536 0 65537 65537 98303 2147450879 2147418113 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 65537 65536 0 0 65537 65537 65537 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147418113 65537 0 0 0 65537 65537 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2147450879 2147450879 2147450879 2147450879 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 98303 2147450879 2147450879 2147418113 65537 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 2147450879 2147450879 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 65537 65536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)]! !

!SpeechBubbleMorph class methodsFor: 'parts bin' stamp: 'Richo 7/2/2010 18:50'!
thoughtGraphicPrototype
	^self form: (ScriptingSystem formAtKey: 'Painting') type: #thought! !

!SpeechBubbleMorph class methodsFor: 'parts bin' stamp: 'Richo 6/16/2010 21:33'!
thoughtPrototype
	^self string: 'Hello world!!' type: #thought! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/16/2010 20:50'!
topLeftCornerForm
"
topLeftCornerForm := nil
(SketchMorph withForm: topLeftCornerForm) openInHand
"
^topLeftCornerForm ifNil: [topLeftCornerForm := (Form
	extent: 25@25
	depth: 16
	fromArray: #( 0 0 0 0 0 0 0 1 65537 65537 65537 65537 65536 0 0 0 0 0 1 65537 65537 65537 65537 65537 65537 65536 0 0 0 0 1 65537 65537 65537 2147450879 2147450879 2147450879 2147450879 2147418112 0 0 0 1 65537 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 0 0 65537 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 0 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 1 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 1 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 98303 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112 65537 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147418112)
	offset: 0@0)]! !

!SpeechBubbleMorph class methodsFor: 'forms' stamp: 'Richo 6/14/2010 11:15'!
topRightCornerForm
^self topLeftCornerForm flipBy: #horizontal centerAt:  self topLeftCornerForm boundingBox leftCenter! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 21:23'!
balloon
	^balloon ifNil: [
		| balloonForm |
		balloonForm := Form extent: self extent - (0 @ self tailHeight) depth: 16.
		self drawBalloonOn: balloonForm getCanvas in: balloonForm boundingBox.
		balloonForm floodFill: self color at: balloonForm center.
		balloon := (SketchMorph withForm: balloonForm).
	]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 21:23'!
color: aColor
	super color: aColor.
	self refresh! !

!SpeechBubbleMorph methodsFor: 'testing' stamp: 'Richo 6/14/2010 16:41'!
containsPoint: aPoint
^ (self bounds containsPoint: aPoint) and:
	  [(self imageForm isTransparentAt: aPoint - bounds origin) not]
! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 21:02'!
defaultColor
	^Color white! !

!SpeechBubbleMorph methodsFor: 'initialize-release' stamp: 'Richo 7/9/2010 20:19'!
delete
	super delete.
	target := msgMorph := type := nil.
! !

!SpeechBubbleMorph methodsFor: 'drawing' stamp: 'Richo 6/14/2010 15:20'!
drawBalloonOn: aCanvas in: sourceRect
| cornerBounds rect1 rect2 |
cornerBounds := self class topLeftCornerForm boundingBox.
aCanvas translucentImage: self class topLeftCornerForm at: sourceRect topLeft;
		translucentImage: self class topRightCornerForm at: sourceRect topRight - (cornerBounds width @ 0);
		translucentImage: self class bottomLeftCornerForm at: sourceRect bottomLeft - (0 @ (cornerBounds height));
		translucentImage: self class bottomRightCornerForm at: sourceRect bottomRight - cornerBounds extent.

rect1 := sourceRect topLeft + (cornerBounds width @ 1) corner: sourceRect bottomRight - (cornerBounds width @ 1).
rect2 := sourceRect topLeft + (1 @ cornerBounds height) corner: sourceRect bottomRight - (1 @ cornerBounds height).
aCanvas fillRectangle: rect1 color: Color white; fillRectangle: rect2 color: Color white.
aCanvas line: rect1 topLeft to: rect1 topRight width: 2 color: Color black;
		line: rect1 bottomLeft to: rect1 bottomRight width: 2 color: Color black;
		line: rect2 topLeft to: rect2 bottomLeft width: 2 color: Color black;
		line: rect2 topRight to: rect2 bottomRight width: 2 color: Color black.
! !

!SpeechBubbleMorph methodsFor: 'drawing' stamp: 'Richo 6/16/2010 20:56'!
drawOn: aCanvas! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 12:43'!
extent: aPoint
| width height |
width := aPoint x max: self minimumAcceptedWidth.
height := aPoint y max: self minimumAcceptedHeight.
super extent: width @ height.
self refresh.
target notNil ifTrue: [self positionMyselfAccordingToTarget]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 20:59'!
fillStyle: aFillStyle
	super fillStyle: aFillStyle.
	self refresh! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 13:44'!
form
^(msgMorph isKindOf: SketchMorph) ifTrue: [msgMorph form]! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 6/14/2010 16:31'!
incrementStepTime
	stepTime := (stepTime + 1) min: self maximumStepTime! !

!SpeechBubbleMorph methodsFor: 'initialize-release' stamp: 'Richo 7/9/2010 20:09'!
initialize
super initialize.
stepTime := self minimumStepTime.
self positionBalloon; positionTail; positionMsgMorph.
self addMorph: self balloon; addMorph: self tail; addMorph: self msgMorph.
self extent: self msgMorphExtent + (20 @ self tailHeight + 20); color: Color white.! !

!SpeechBubbleMorph methodsFor: 'event handling' stamp: 'Richo 7/6/2010 13:02'!
keyStroke: anEvent morph: aMorph 
	| string |
	(self msgMorph isKindOf: UserText) ifFalse: [^self].

	string := self msgMorph contents.

	"Update text width if necessary. Make sure we keep the selection at the end of the text so that the user can keep modifying"
	self msgMorph width > 300
		ifTrue: [self msgMorph contents: string wrappedTo: 300.
			self msgMorph editor selectFrom: string size + 1 to: string size].

	"Update my extent"
	self extent: self msgMorphExtent + (20 @ self tailHeight + 20).
! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 6/17/2010 00:11'!
maximumStepTime
	^500! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 13:18'!
minimumAcceptedHeight
^100 max: self msgMorph fullBounds height + 20 + self tailHeight! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 13:18'!
minimumAcceptedWidth
^ 175 max: self msgMorph fullBounds width + 20! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 6/14/2010 16:32'!
minimumStepTime
	^20! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/9/2010 20:20'!
msgMorph
^msgMorph isNil ifTrue: [nil] ifFalse: [msgMorph topRendererOrSelf]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 13:17'!
msgMorphExtent
^self msgMorph fullBounds extent! !

!SpeechBubbleMorph methodsFor: 'initialize-release' stamp: 'Richo 6/14/2010 15:41'!
positionBalloon
self balloon position: self position! !

!SpeechBubbleMorph methodsFor: 'initialize-release' stamp: 'Richo 7/6/2010 13:24'!
positionMsgMorph
| diff |
diff := self msgMorph center - self msgMorph fullBounds center.
self msgMorph center: self center - (0 @ self tailHeight / 2) + diff.! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 7/9/2010 20:16'!
positionMyselfAccordingToTarget
	| newCenter newOwner |
	"Modify mi position"
	newCenter := target topRendererOrSelf center - (0 @ ((target topRendererOrSelf height + self height) / 2)).
	self privatePosition: newCenter - (self extent // 2).
	"Don't forget to check if my owner is still the right one. Maybe the morph was inside a Playfield and the user grabed it and put it in the World"
	newOwner := target ownerThatIsA: PasteUpMorph.
	self owner ~= newOwner ifTrue: [newOwner addMorph: self]! !

!SpeechBubbleMorph methodsFor: 'initialize-release' stamp: 'Richo 6/14/2010 15:40'!
positionTail
self tail position: self bottomCenter - (0 @ self tailHeight + 2)! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 17:11'!
position: aPoint
target notNil ifTrue: [^self positionMyselfAccordingToTarget ].
super position: aPoint.! !

!SpeechBubbleMorph methodsFor: 'private' stamp: 'Richo 6/19/2010 14:15'!
privatePosition: aPoint
"Always changes the position, regardless of the target"
super position: aPoint! !

!SpeechBubbleMorph methodsFor: 'refreshing' stamp: 'Richo 7/6/2010 12:56'!
refresh
self refreshBalloon; refreshTail; refreshMsgMorph! !

!SpeechBubbleMorph methodsFor: 'refreshing' stamp: 'Richo 6/14/2010 15:49'!
refreshBalloon
	balloon ifNotNil: [balloon delete].
	balloon := nil.
	self positionBalloon.
	self addMorph: balloon! !

!SpeechBubbleMorph methodsFor: 'refreshing' stamp: 'Richo 7/9/2010 20:21'!
refreshMsgMorph
	self msgMorph owner = self ifFalse: [^self delete].
	self positionMsgMorph.
	self addMorph: self msgMorph! !

!SpeechBubbleMorph methodsFor: 'refreshing' stamp: 'Richo 6/14/2010 15:50'!
refreshTail
	tail ifNotNil: [tail delete].
	tail := nil.
	self positionTail.
	self addMorph: tail! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/14/2010 15:19'!
selectedTailForm
	^type caseOf: {
		[#speech] -> [self class speakingForm].
		[#thought] -> [self class thinkingForm].
		} otherwise: [self error: 'Wrong type']! !

!SpeechBubbleMorph methodsFor: 'private' stamp: 'Richo 7/6/2010 12:46'!
setMorph: aMorph type: aSymbol
	msgMorph := aMorph.
	type := aSymbol! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 7/9/2010 20:28'!
step
(target isNil or: [lastHash = (lastHash := target boundsSignatureHash)])
		ifTrue: [self incrementStepTime]
		ifFalse: [stepTime := self minimumStepTime].

target notNil ifTrue: [
target isInWorld ifFalse: [^self delete].
self positionMyselfAccordingToTarget].

"This will keep the correct extent if the graphic changed"
self msgMorph notNil ifTrue: [
(self balloon fullBounds containsRect: self msgMorph fullBounds)
	ifFalse: [self extent: 1@1]]
! !

!SpeechBubbleMorph methodsFor: 'stepping' stamp: 'Richo 6/14/2010 16:34'!
stepTime
^stepTime ! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 7/6/2010 13:44'!
string
^(msgMorph isKindOf: UserText) ifTrue: [msgMorph contents]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 21:24'!
tail
^tail ifNil: [
	| tailForm |
	tailForm := self selectedTailForm deepCopy.
	
	"This will paint both forms correctly"
	tailForm floodFill: self color at: tailForm center + (6@-15).

	"In the #thought case, we also need to paint the little bubbles"
	type = #thought ifTrue: [
		tailForm floodFill: self color at: tailForm center + (-7@7);
				floodFill: self color at: tailForm center + (-22@20)
	].

	tail := SketchMorph withForm: tailForm]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/14/2010 15:36'!
tailHeight
^self tail height! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 23:58'!
target
	^target! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/16/2010 21:47'!
target: aMorph
	target := aMorph.
	target notNil ifTrue: [self positionMyselfAccordingToTarget ]! !

!SpeechBubbleMorph methodsFor: 'accessing' stamp: 'Richo 6/14/2010 16:43'!
type
^type! !
